/*!
 * wbm-runtime-information@1.1.2
 * 
 *   Copyright © 2020 WAGO Kontakttechnik GmbH & Co. KG
 * 
 *   License: 
 *     WAGO Software License Agreement
 * 
 *   Contributors:
 *     
 * 
 *   Description:
 *     CODESYS and e!RUNTIME information.
 * 
 *   
 */
!function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t():"function"==typeof define&&define.amd?define([],t):"object"==typeof exports?exports["runtime-information"]=t():e["runtime-information"]=t()}(window,(function(){return function(e){var t={};function n(r){if(t[r])return t[r].exports;var i=t[r]={i:r,l:!1,exports:{}};return e[r].call(i.exports,i,i.exports,n),i.l=!0,i.exports}return n.m=e,n.c=t,n.d=function(e,t,r){n.o(e,t)||Object.defineProperty(e,t,{enumerable:!0,get:r})},n.r=function(e){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},n.t=function(e,t){if(1&t&&(e=n(e)),8&t)return e;if(4&t&&"object"==typeof e&&e&&e.__esModule)return e;var r=Object.create(null);if(n.r(r),Object.defineProperty(r,"default",{enumerable:!0,value:e}),2&t&&"string"!=typeof e)for(var i in e)n.d(r,i,function(t){return e[t]}.bind(null,i));return r},n.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return n.d(t,"a",t),t},n.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},n.p="",n(n.s=0)}([function(e,t,n){"use strict";var r=this&&this.__awaiter||function(e,t,n,r){return new(n||(n=Promise))((function(i,o){function a(e){try{u(r.next(e))}catch(e){o(e)}}function l(e){try{u(r.throw(e))}catch(e){o(e)}}function u(e){e.done?i(e.value):new n((function(t){t(e.value)})).then(a,l)}u((r=r.apply(e,t||[])).next())}))},i=this&&this.__generator||function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function l(o){return function(l){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=(i=a.trys).length>0&&i[i.length-1])&&(6===o[0]||2===o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,l])}}};Object.defineProperty(t,"__esModule",{value:!0});var o=n(1);base.plugin.register("wbm-runtime-information",(function(e){return r(this,void 0,void 0,(function(){var t;return i(this,(function(r){return(t=n(8)).content[1].sections.push(new o.WebVisu(e)),[2,{id:"runtime-information",title:{fallback:"PLC Runtime",key:"plc-runtime-information-menu-title"},priority:17,controller:e.viewGenerator.generate(e,t)}]}))}))}))},function(e,t,n){"use strict";var r,i=this&&this.__extends||(r=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])},function(e,t){function n(){this.constructor=e}r(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}),o=this&&this.__awaiter||function(e,t,n,r){return new(n||(n=Promise))((function(i,o){function a(e){try{u(r.next(e))}catch(e){o(e)}}function l(e){try{u(r.throw(e))}catch(e){o(e)}}function u(e){e.done?i(e.value):new n((function(t){t(e.value)})).then(a,l)}u((r=r.apply(e,t||[])).next())}))},a=this&&this.__generator||function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function l(o){return function(l){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=(i=a.trys).length>0&&i[i.length-1])&&(6===o[0]||2===o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,l])}}};Object.defineProperty(t,"__esModule",{value:!0});var l=n(2);n(3);var u=n(7),s=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t.view=document.createElement("wbm-runtime-information-webvisu"),t}return i(t,e),t.prototype.load=function(){return o(this,void 0,void 0,(function(){var e;return a(this,(function(t){return e=this.base.browser.browserType===u.BrowserType.eDisplay?"":'target="_blank"',this.view.innerHTML="<a "+e+' href="/webvisu/webvisu.htm">Open WebVisu</a>',[2]}))}))},t}(l.ViewController);t.WebVisu=s},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=function(){function e(e){this.base=e}return e.prototype.onRouteChange=function(e){},e.prototype.unload=function(){},e}();t.ViewController=r},function(e,t,n){var r=n(4);"string"==typeof r&&(r=[[e.i,r,""]]);var i={insert:"head",singleton:!1};n(6)(r,i);r.locals&&(e.exports=r.locals)},function(e,t,n){(e.exports=n(5)(!1)).push([e.i,"wbm-runtime-information-webvisu a {\n    margin: 9px;\n    display: block;\n}",""])},function(e,t,n){"use strict";e.exports=function(e){var t=[];return t.toString=function(){return this.map((function(t){var n=function(e,t){var n=e[1]||"",r=e[3];if(!r)return n;if(t&&"function"==typeof btoa){var i=(a=r,l=btoa(unescape(encodeURIComponent(JSON.stringify(a)))),u="sourceMappingURL=data:application/json;charset=utf-8;base64,".concat(l),"/*# ".concat(u," */")),o=r.sources.map((function(e){return"/*# sourceURL=".concat(r.sourceRoot).concat(e," */")}));return[n].concat(o).concat([i]).join("\n")}var a,l,u;return[n].join("\n")}(t,e);return t[2]?"@media ".concat(t[2],"{").concat(n,"}"):n})).join("")},t.i=function(e,n){"string"==typeof e&&(e=[[null,e,""]]);for(var r={},i=0;i<this.length;i++){var o=this[i][0];null!=o&&(r[o]=!0)}for(var a=0;a<e.length;a++){var l=e[a];null!=l[0]&&r[l[0]]||(n&&!l[2]?l[2]=n:n&&(l[2]="(".concat(l[2],") and (").concat(n,")")),t.push(l))}},t}},function(e,t,n){"use strict";var r,i={},o=function(){return void 0===r&&(r=Boolean(window&&document&&document.all&&!window.atob)),r},a=function(){var e={};return function(t){if(void 0===e[t]){var n=document.querySelector(t);if(window.HTMLIFrameElement&&n instanceof window.HTMLIFrameElement)try{n=n.contentDocument.head}catch(e){n=null}e[t]=n}return e[t]}}();function l(e,t){for(var n=[],r={},i=0;i<e.length;i++){var o=e[i],a=t.base?o[0]+t.base:o[0],l={css:o[1],media:o[2],sourceMap:o[3]};r[a]?r[a].parts.push(l):n.push(r[a]={id:a,parts:[l]})}return n}function u(e,t){for(var n=0;n<e.length;n++){var r=e[n],o=i[r.id],a=0;if(o){for(o.refs++;a<o.parts.length;a++)o.parts[a](r.parts[a]);for(;a<r.parts.length;a++)o.parts.push(v(r.parts[a],t))}else{for(var l=[];a<r.parts.length;a++)l.push(v(r.parts[a],t));i[r.id]={id:r.id,refs:1,parts:l}}}}function s(e){var t=document.createElement("style");if(void 0===e.attributes.nonce){var r=n.nc;r&&(e.attributes.nonce=r)}if(Object.keys(e.attributes).forEach((function(n){t.setAttribute(n,e.attributes[n])})),"function"==typeof e.insert)e.insert(t);else{var i=a(e.insert||"head");if(!i)throw new Error("Couldn't find a style target. This probably means that the value for the 'insert' parameter is invalid.");i.appendChild(t)}return t}var c,f=(c=[],function(e,t){return c[e]=t,c.filter(Boolean).join("\n")});function d(e,t,n,r){var i=n?"":r.css;if(e.styleSheet)e.styleSheet.cssText=f(t,i);else{var o=document.createTextNode(i),a=e.childNodes;a[t]&&e.removeChild(a[t]),a.length?e.insertBefore(o,a[t]):e.appendChild(o)}}function p(e,t,n){var r=n.css,i=n.media,o=n.sourceMap;if(i&&e.setAttribute("media",i),o&&btoa&&(r+="\n/*# sourceMappingURL=data:application/json;base64,".concat(btoa(unescape(encodeURIComponent(JSON.stringify(o))))," */")),e.styleSheet)e.styleSheet.cssText=r;else{for(;e.firstChild;)e.removeChild(e.firstChild);e.appendChild(document.createTextNode(r))}}var m=null,y=0;function v(e,t){var n,r,i;if(t.singleton){var o=y++;n=m||(m=s(t)),r=d.bind(null,n,o,!1),i=d.bind(null,n,o,!0)}else n=s(t),r=p.bind(null,n,t),i=function(){!function(e){if(null===e.parentNode)return!1;e.parentNode.removeChild(e)}(n)};return r(e),function(t){if(t){if(t.css===e.css&&t.media===e.media&&t.sourceMap===e.sourceMap)return;r(e=t)}else i()}}e.exports=function(e,t){(t=t||{}).attributes="object"==typeof t.attributes?t.attributes:{},t.singleton||"boolean"==typeof t.singleton||(t.singleton=o());var n=l(e,t);return u(n,t),function(e){for(var r=[],o=0;o<n.length;o++){var a=n[o],s=i[a.id];s&&(s.refs--,r.push(s))}e&&u(l(e,t),t);for(var c=0;c<r.length;c++){var f=r[c];if(0===f.refs){for(var d=0;d<f.parts.length;d++)f.parts[d]();delete i[f.id]}}}}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),function(e){e.desktop="desktop",e.touch="touch",e.eDisplay="eDisplay"}(t.BrowserType||(t.BrowserType={}))},function(e){e.exports=JSON.parse('{"title":{"default":"PLC Runtime Information","localized":"unique-translation-key-for-the-page-title"},"content":[{"title":{"default":"Runtime","localized":"runtime-information-runtime-form-title"},"sections":[{"fields":[{"title":{"default":"Version","localized":"runtime-information-runtime-version-field-title"},"parameter":"runtime.version","options":{"readonly":true},"control":{"type":"dropdown","items":[{"repeat":"runtime.availableversions.*.id","value":"${runtime.availableversions.*.id}","title":{"localized":"${runtime.availableversions.*.id}-dropdown-item","default":"${runtime.availableversions.*.name}"}}]}},{"hidden":"runtime.version is not 2","title":{"default":"Webserver version","localized":"runtime-information-runtime-webserver-version-field-title"},"parameter":"runtime.codesys2.webserver.version","options":{"readonly":true},"control":{"type":"textfield"}},{"hidden":"runtime.version is not 2","title":{"default":"State","localized":"runtime-information-runtime-webserver-state-title"},"parameter":"runtime.codesys2.state","options":{"readonly":true},"control":{"type":"textfield"}},{"hidden":"runtime.version is not 2","title":{"default":"Number of tasks","localized":"runtime-information-runtime-number-of-tasks-field-title"},"parameter":"runtime.codesys2.taskscount","options":{"readonly":true},"control":{"type":"textfield"}}]}]},{"title":{"default":"WebVisu","localized":"runtime-information-webvisu-form-title"},"sections":[]},{"hidden":"runtime.version is not 2","title":{"default":"Project Details","localized":"runtime-information-project-details-form-title"},"sections":[{"fields":[{"title":{"default":"Date","localized":"runtime-information-project-details-date-field-title"},"parameter":"runtime.codesys2.project.date","options":{"readonly":true},"control":{"type":"textfield"}},{"title":{"default":"Title","localized":"runtime-information-project-details-title-field-title"},"parameter":"runtime.codesys2.project.title","options":{"readonly":true},"control":{"type":"textfield"}},{"title":{"default":"Version","localized":"runtime-information-project-details-version-field-title"},"parameter":"runtime.codesys2.project.version","options":{"readonly":true},"control":{"type":"textfield"}},{"title":{"default":"Author","localized":"runtime-information-project-details-author-field-title"},"parameter":"runtime.codesys2.project.author","options":{"readonly":true},"control":{"type":"textfield"}},{"title":{"default":"Description","localized":"runtime-information-project-details-description-field-title"},"parameter":"runtime.codesys2.project.description","options":{"readonly":true},"control":{"type":"textfield","options":{"multiline":true}}},{"title":{"default":"Checksum","localized":"runtime-information-project-details-checksum-field-title"},"parameter":"runtime.codesys2.project.checksum","options":{"readonly":true},"control":{"type":"textfield"}}]}]},{"hidden":"runtime.version is not 2","repeat":"runtime.codesys2.tasks.*.index","title":{"default":"Task ${runtime.codesys2.tasks.*.index}: ${runtime.codesys2.tasks.*.name}, ID: ${runtime.codesys2.tasks.*.id}","localized":"runtime-information-task-form-title"},"sections":[{"fields":[{"title":{"default":"Cycle count","localized":"runtime-information-task-cyle-count-field-title"},"parameter":"runtime.codesys2.tasks.*.cylecount","options":{"readonly":true},"control":{"type":"textfield"}},{"title":{"default":"Cycle time (usec)","localized":"runtime-information-task-cyle-time-field-title"},"parameter":"runtime.codesys2.tasks.*.cyletime","options":{"readonly":true},"control":{"type":"textfield"}},{"title":{"default":"Cycle time min (usec)","localized":"runtime-information-task-cyle-time-min-field-title"},"parameter":"runtime.codesys2.tasks.*.minimumcyletime","options":{"readonly":true},"control":{"type":"textfield"}},{"title":{"default":"Cycle time max (usec)","localized":"runtime-information-task-cyle-time-max-field-title"},"parameter":"runtime.codesys2.tasks.*.maximumcyletime","options":{"readonly":true},"control":{"type":"textfield"}},{"title":{"default":"Cycle time avg (usec)","localized":"runtime-information-task-cyle-time-avg-field-title"},"parameter":"runtime.codesys2.tasks.*.averagecyletime","options":{"readonly":true},"control":{"type":"textfield"}},{"title":{"default":"State","localized":"runtime-information-task-state-field-title"},"parameter":"runtime.codesys2.tasks.*.state","options":{"readonly":true},"control":{"type":"textfield"}},{"title":{"default":"Mode","localized":"runtime-information-task-mode-field-title"},"parameter":"runtime.codesys2.tasks.*.mode","options":{"readonly":true},"control":{"type":"textfield"}},{"title":{"default":"Priority","localized":"runtime-information-task-priority-field-title"},"parameter":"runtime.codesys2.tasks.*.priority","options":{"readonly":true},"control":{"type":"textfield"}},{"title":{"default":"Interval (${runtime.codesys2.tasks.*.intervalunit})","localized":"runtime-information-task-interval-field-title"},"parameter":"runtime.codesys2.tasks.*.interval","options":{"readonly":true},"control":{"type":"textfield"}}]}]}]}')}])}));
//# sourceMappingURL=runtime-information.js.map